/*
 * (c) 2006 Red Hat, Inc.
 *
 * This program is open source software licensed under the 
 * Eclipse Public License ver. 1
 */
package com.redhat.eclipse.changelog.core;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.ui.IEditorPart;

public class ChangeLogWriter {

	private String entryFilePath = null;

	private String guessedFName = null;

	private IFormatterChangeLogContrib formatter = null;

	private IEditorPart changelog = null;

	private String dateLine = null;

	private String changelogLocation = null;

	public IEditorPart getChangelog() {
		return changelog;
	}

	public void setChangelog(IEditorPart changelog) {
		this.changelog = changelog;
	}

	public String getChangelogLocation() {
		return changelogLocation;
	}

	public void setChangelogLocation(String changelogLocation) {
		this.changelogLocation = changelogLocation;
	}

	public String getDateLine() {
		return dateLine;
	}

	public void setDateLine(String dateLine) {
		this.dateLine = dateLine;
	}

	public String getEntryFilePath() {
		return entryFilePath;
	}

	public void setEntryFilePath(String entryFilePath) {
		this.entryFilePath = entryFilePath;
	}

	public IFormatterChangeLogContrib getFormatter() {
		return formatter;
	}

	public void setFormatter(IFormatterChangeLogContrib formatter) {
		this.formatter = formatter;
	}

	public String getGuessedFName() {
		return guessedFName;
	}

	public void setGuessedFName(String guessedFName) {
		this.guessedFName = guessedFName;
	}

	public void writeChangeLog() {

		// System.out.println("Debug Output :");
		// System.out.println(entryFilePath);
		// System.out.println(guessedFName);
		// System.out.println(formatter);
		// System.out.println(changelog);
		// System.out.println(dateLine);
		// System.out.println(changelogLocation);
		// System.out.println("\n");

		if (entryFilePath == null || guessedFName == null || formatter == null
				|| changelog == null || dateLine == null
				|| changelogLocation == null) {
			ChangelogPlugin.getDefault().getLog().log(
					new Status(IStatus.ERROR, "Changelog", IStatus.ERROR,
							"Some element not set to write a Changelog", null));

			return;
		}

		formatter.mergeChangelog(dateLine, guessedFName, changelog,
				changelogLocation, entryFilePath);

	}

}
