/*
 * (c) 2006 Red Hat, Inc.
 *
 * This program is open source software licensed under the 
 * Eclipse Public License ver. 1
 */
package com.redhat.eclipse.changelog.core;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;

/**
 * @author pmuldoon (Phil Muldoon)
 */
public interface IParserChangeLogContrib {

	/**
	 * Used to determine function name from a currently open editor, where the
	 * cursor is at. Used by KeyAction.
	 * 
	 * @param editor
	 * @return
	 * @throws CoreException
	 */
	public String parseCurrentFunction(IEditorPart editor) throws CoreException;

	/**
	 * Used to determine function name from and editor input, with offset
	 * supplied manualy. Used by prepare changelog.
	 * 
	 * @param input
	 * @param offset
	 * @return
	 * @throws CoreException
	 */
	public String parseCurrentFunction(IEditorInput input, int offset)
			throws CoreException;

}
