/*
 * (c) 2006 Red Hat, Inc.
 *
 * This program is open source software licensed under the 
 * Eclipse Public License ver. 1
 */
package com.redhat.eclipse.changelog.core.editors;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.hyperlink.IHyperlink;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PartInitException;
import com.redhat.eclipse.changelog.core.ChangelogPlugin;

/**
 * Hyperlink that opens up editor for a file.
 * 
 * @author klee (Kyu Lee)
 * 
 */
public class FileHyperlink implements IHyperlink {

	private IFile fileLoc;

	private IRegion region;

	public FileHyperlink(IRegion regionIn, IFile fileIn) {
		fileLoc = fileIn;
		region = regionIn;
	}

	public IRegion getHyperlinkRegion() {
		return region;
	}

	public String getTypeLabel() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getHyperlinkText() {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * Opens the hyperlink in new editor window.
	 */
	public void open() {
		IWorkbench ws = getWorkbench();

		try {

			org.eclipse.ui.ide.IDE.openEditor(ws.getActiveWorkbenchWindow()
					.getActivePage(), fileLoc, true);
		} catch (PartInitException e) {
			e.printStackTrace();

		}

	}

	private IWorkbench getWorkbench() {
		return ChangelogPlugin.getDefault().getWorkbench();
	}

}
